 <!DOCTYPE html>
<html>
  <head>
    <title>Coordenadas 2D a 3D</title>
    <style>
      html, body { margin: 0; padding: 0; overflow: hidden; }
    </style>
  </head>
  <body>
    <script src="js/three.min.js"></script>
    <script>
		var scene, aspect, camera, renderer;
		var startTime = Date.now();
		
		init();
		animate();
	
		function init(){
			scene = new THREE.Scene();
			aspect = window.innerWidth / window.innerHeight;
			camera = new THREE.PerspectiveCamera( 45, aspect, 0.1, 1000);
			renderer = new THREE.WebGLRenderer();
			renderer.setSize( window.innerWidth, window.innerHeight );
			document.body.appendChild( renderer.domElement );
				  
		var size = 20;
			var arrowSize = 1;
			var divisions = size;
			var origin = new THREE.Vector3( 0, 0, 0 );
			var x = new THREE.Vector3( 1, 0, 0 );
			var y = new THREE.Vector3( 0, 1, 0 );
		  	var z = new THREE.Vector3( 0, 0, 1 );
			var color1 = new THREE.Color( 0xFFFFFF );
		  	var color2 = new THREE.Color( 0x333333 );
		  	var colorR = new THREE.Color( 0xAA0000 );
		  	var colorG = new THREE.Color( 0x00AA00 );
		  	var colorB = new THREE.Color( 0x0000AA );
			var colorRd = new THREE.Color( 0xAA6666 );
		  	var colorGd = new THREE.Color( 0x66AA66 );
		  	var colorBd = new THREE.Color( 0x6666AA );
			
		  
		  	//CREAR LAS GRILLAS
		  	var axesHelper = new THREE.AxesHelper( size );
		  	var gridHelperXY = new THREE.GridHelper( size, divisions, color1, color1);
		  	var gridHelperXZ = new THREE.GridHelper( size, divisions, color2, color2 );
		  	var gridHelperYZ = new THREE.GridHelper( size, divisions, color2, color2 );
  
		  	//ROTARLAS PARA QUE QUEDEN EN EL ESPACIO ADECUADO
		  	gridHelperXY.rotateOnWorldAxis ( x, THREE.Math.degToRad(90) );
		 	gridHelperXZ.rotateOnWorldAxis ( y, THREE.Math.degToRad(90) );
		  	gridHelperYZ.rotateOnWorldAxis ( z, THREE.Math.degToRad(90) );
  
		 	 var arrowX = new THREE.ArrowHelper( x, origin, arrowSize, colorR );
		 	 var arrowY = new THREE.ArrowHelper( y, origin, arrowSize, colorG );
		 	 var arrowZ = new THREE.ArrowHelper( z, origin, arrowSize, colorB );
			 
			 //CREAR GEOMETRIA
			 var geometry = new THREE.SphereGeometry(0.9, 50 , 16); // sol
			 var material1 = new THREE.MeshBasicMaterial( {color: 0xFFA00A} );
			 
			 var geometry2 = new THREE.SphereGeometry(0.15, 50 , 16);
			 var material2 = new THREE.MeshBasicMaterial( {color: 0x9F660F} );
			 
			 var geometry3 = new THREE.SphereGeometry(0.45, 50 , 16);
			 var material3 = new THREE.MeshBasicMaterial( {color: 0x8C876B} );
			 
			 var geometry4 = new THREE.SphereGeometry(0.35, 50 , 16);
			 var material4 = new THREE.MeshBasicMaterial( {color: 0x95C8D7} );
			 
			 var geometry5 = new THREE.SphereGeometry(0.07, 50 , 16); //luna
			 var material5 = new THREE.MeshBasicMaterial( {color: 0xABADAD} );
			 
			 var geometry6 = new THREE.SphereGeometry(0.3, 50 , 16);
			 var material6 = new THREE.MeshBasicMaterial( {color: 0xC54848} );
			 
			 var geometry7 = new THREE.SphereGeometry(0.6, 50 , 16);
			 var material7 = new THREE.MeshBasicMaterial( {color: 0x24BAA7} );
			 
			 var geometry8 = new THREE.SphereGeometry(0.38, 50 , 16);
			 var material8 = new THREE.MeshBasicMaterial( {color: 0xF4BC6F} );
			 
			 var geometry9 = new THREE.RingGeometry( 0.6, 0.8, 50 );
			 var material9 = new THREE.MeshBasicMaterial( { color: 0xF4BC6F, side: THREE.DoubleSide } ); // anillo
			 
			 //CREAR LOS OBJETOS
			var esfera1 = new THREE.Mesh(geometry, material1); // ESFERA 1
			scene.add(esfera1);
			var esfera2 = new THREE.Mesh(geometry2, material2); // ESFERA 2
			scene.add(esfera2);
			esfera2.position.x = 0.1 ;
			esfera2.position.y = 0.1 ;
			esfera2.position.z = 1.8 ;
			
			var esfera3 = new THREE.Mesh(geometry3, material3); // ESFERA 3
			scene.add(esfera3);
			esfera3.position.x = 0.1 ;
			esfera3.position.y = 0.1 ;
			esfera3.position.z = 2.8 ;
			
			var esfera4 = new THREE.Mesh(geometry4, material4); // ESFERA 4
			scene.add(esfera4);
			esfera4.position.x = 0.1 ;
			esfera4.position.y = 0.1 ;
			esfera4.position.z = 3.8 ;
		  
			var esfera5 = new THREE.Mesh(geometry5, material5); // ESFERA 5
			scene.add(esfera5);
			esfera5.position.x = 0.1 ;
			esfera5.position.y = 0.1 ;
			esfera5.position.z = 4.5 ;
			
			var esfera6 = new THREE.Mesh(geometry6,material6); // ESFERA 6
			scene.add(esfera6);
			esfera6.position.x = 0.1 ;
			esfera6.position.y = 0.1 ;
			esfera6.position.z = 5.1 ;
			
			var esfera7 = new THREE.Mesh(geometry7, material7); // ESFERA 7

			esfera7.position.x = 0.1 ;
			esfera7.position.y = 0.1 ;
			esfera7.position.z = 6.3 ;
			
			var esfera8 = new THREE.Mesh(geometry8, material8); // ESFERA 8
			esfera8.position.x = 0.1 ;
			esfera8.position.y = 0.1 ;
			esfera8.position.z = 7.9 ;
			
			var anillo9 = new THREE.Mesh( geometry9, material9 ); // ANILLO 9
			scene.add(anillo9);
			anillo9.position.x = 0.1 ;
			anillo9.position.y = 0.1 ;
			anillo9.position.z = 7.9 ;
			anillo9.rotation.x = Math.sin(90);
			//anillo9.rotation.y = 0;
			//anillo9.rotation.z = 0;
	           
            esfera7.add(esfera8);
		  	//AGREGAR A LA ESCENA
		  	
		  	scene.add( gridHelperXZ );		
		  	scene.add( arrowX );	
		  	scene.add( arrowY );	
		  	scene.add( arrowZ );			
            scene.add(esfera7);
		  	camera.position.x = -25;
			camera.position.y = 10;	 
		  	camera.position.z = 0;			
		  	camera.lookAt( origin );
			var loader = new THREE.TextureLoader();
				loader.load( 'textures/land_ocean_ice_cloud_2048.jpg', function ( texture ) {
					var geometry = new THREE.SphereBufferGeometry( 200, 20, 20 );
					var material = new THREE.MeshBasicMaterial( { map: texture, overdraw: 0.5 } );
					var mesh = new THREE.Mesh( geometry, material );
					group.add( mesh );
				} );

			}
			
		function animate(){
			render();
			requestAnimationFrame( animate );
		}
		
		function render(){
			var dtime = Date.now()-startTime;
			 var dtime = Date.now()-startTime;
		var tx=0, ty=0, tz=0;	//Variables para traslacion
		var sc = 1;				//Variable para escala
		var theta=0;			//Variable para ángulo de rotacion de piernas
		var sigma=0;			//Variable para ángulo de rotación de caderas
		
		if(thetaSum>=25*Math.PI/180)
			positivo = false;
		if(thetaSum<=-25*Math.PI/180)
			positivo = true;
		
		if(upArrow) {
			tx=0; ty=0; tz=.1;
			if(positivo)
				theta = .1;
			else
				theta = -.1;
		}
		if(downArrow) {
			tx=0; ty=0; tz=-.1;
			if(positivo)
				theta = .1;
			else
				theta = -.1;
		}
		thetaSum+=theta;
		
		if(rightArrow)
			sigma = -.1;
		if(leftArrow)
			sigma = .1;
		
		//MATRIZ DE TRASLACIÓN
		var t = new THREE.Matrix4();
		t.set( 	1, 0, 0, tx,
				0, 1, 0, ty, 
				0, 0, 1, tz,
				0, 0, 0, 1	);
		
		hips.matrix.multiply(t); 	//APLICAR LA TRASLACIÓN A NIVEL LOCAL
		
		//ROTACIONES
		var ct1 = Math.cos(theta);
		var ct2 = Math.cos(-theta);
		var cs = Math.cos(sigma);
		var st1 = Math.sin(theta);
		var st2 = Math.sin(-theta);
		var ss = Math.sin(sigma);
		var r = new THREE.Matrix4();
		var r1 = new THREE.Matrix4();
		var r2 = new THREE.Matrix4();

		//MATRIZ DE ROTACIÓN EN EJE Y
		r.set( 	   cs,  0, ss, 0,
					0,  1,  0, 0, 
				  -ss,  0, cs, 0,
					0,  0,  0, 1 );	
		var tempMatrix = new THREE.Matrix4();
		tempMatrix.copyPosition( hips.matrix );
		esfera7.applyMatrix( new THREE.Matrix4().getInverse(tempMatrix) );
		esfera7.applyMatrix(r1);
			renderer.render( scene, camera );
		}
    </script>
  </body>
</html>
